/*********************************************************************
 * ArgPerse.cpp
 *     R}hC̓[`
 * 
 *      1. F 2000 N 9  6 
 *         ҎҁF "ĂƁ" <tategoto@harpy.jp>
 *         eF VK쐬
 *      2. F 2000 N 9  13 
 *         ҎҁF "ĂƁ" <tategoto@harpy.jp>
 *         eF wb_[ƃ\[X 2 t@Cɕ
 *                錾ς݃O[oCX^X Arg ̔p~
 *      3. F 2011 N 2  16 
 *         ҎҁF "ĂƁ" <tategoto@harpy.jp>
 *         eF R}hCɃXy[Xꍇ]vȋ
 *                ێȂ悤C
 *********************************************************************/

#include <windows.h>
#include "ArgPerse.h"

#define  ARGPERSE_INDEX_BLOCKSIZE  32

//#define  bool   BOOL
//#define  true   TRUE
//#define  false  FALSE

// BYTE ^ŁAvalue  from  to ̊Ԃ̒lłΐ^AłȂ΋U
#define  BYTE_BETWEEN(from, value, to)  ((BYTE)(from) <= (BYTE)(value) && (BYTE)(value) <= (BYTE)(to))

// LPSTR ^̐擪 2 oCgłΐ^AłȂ΋U
#define  IS_ZENCHAR(s)                  (                                                                                  \
											(BYTE_BETWEEN('\x81', (s)[0], '\x9F') || BYTE_BETWEEN('\xE0', (s)[0], '\xFC')) \
											&&                                                                             \
											(BYTE_BETWEEN('\x40', (s)[1], '\xFC') && (BYTE)((s)[1]) != (BYTE)0x7F)         \
										)


cls_ArgPerse::cls_ArgPerse()
{
	C     = 0;
	V     = NULL;
	mBuf  = NULL;
	mHeap = HeapCreate(HEAP_NO_SERIALIZE, 0, 0);

	LPCSTR  pBuf = GetCommandLine();
	DWORD   sLen = lstrlen(pBuf);

	mBuf = (LPSTR)HeapAlloc(mHeap, HEAP_NO_SERIALIZE, lstrlen(pBuf) * 2 + 1);
	if(mBuf == NULL)
		return;

	int  pIndexCount = ARGPERSE_INDEX_BLOCKSIZE;
	V = (LPSTR *)HeapAlloc(mHeap, HEAP_NO_SERIALIZE, pIndexCount * sizeof(LPSTR));
	if(V == NULL)
		return;

	enum  { InSpace, InArgument, InQuoted }
	      pFlag            = InSpace;
	int   pDestPos         = 0;
	bool  pLastArgNotExist = true;

	V[C++] = mBuf;
	for(DWORD  pBufPos = 0; pBuf[pBufPos]; pBufPos++)
	{
		if(pFlag == InSpace)
		{
			pLastArgNotExist = true;
			do
			{
				switch(pBuf[pBufPos])
				{
					case ' ':
					case '\t':
						pBufPos++;
						break;
					case '\0':
						goto Finish;
					default:
						pFlag = InArgument;
						break;
				}
			} while(pFlag == InSpace);
		}
		if(IS_ZENCHAR(&pBuf[pBufPos]))
		{
			mBuf[pDestPos++] = pBuf[pBufPos++];
			mBuf[pDestPos++] = pBuf[pBufPos];
			continue;
		}
		switch(pBuf[pBufPos])
		{
			case '\\':
				if(pFlag == InQuoted && (pBuf[pBufPos + 1] == '\\' || pBuf[pBufPos + 1] == '\"'))
					mBuf[pDestPos++] = pBuf[++pBufPos];
				else
					mBuf[pDestPos++] = '\\';
				break;
			case '\"':
				if(pFlag == InQuoted)
					pFlag = InArgument;
				else
					pFlag = InQuoted;
				break;
			case ' ':
			case '\t':
				{
					for(LPCSTR  p = &pBuf[pBufPos]; ; ++p)
					{
						switch(*p)
						{
							case ' ':
							case '\t':
								continue;
							case '\0':
								goto Finish;
						}
						break;
					}
				}
				// not break;
			case '/':
				if(
					((pBuf[pBufPos] == ' ' || pBuf[pBufPos] == '\t') && pFlag == InArgument)
					||
					(pBuf[pBufPos] == '/' && V[C - 1] != &mBuf[pDestPos])
				  )
				{
					mBuf[pDestPos++] = '\0';
					if(C >= pIndexCount)
					{
						pIndexCount += ARGPERSE_INDEX_BLOCKSIZE;
						LPVOID  pTempBuf = HeapReAlloc(mHeap, HEAP_NO_SERIALIZE, V, pIndexCount * sizeof(LPSTR));
						if(pTempBuf == NULL)
							return;
						V = (LPSTR *)pTempBuf;
					}
					V[C++] = &mBuf[pDestPos];
					if(pBuf[pBufPos] != '/')
					{
						pFlag = InSpace;
						break;
					}
				}
				// not break;
			default:
				mBuf[pDestPos++] = pBuf[pBufPos];
				pLastArgNotExist = false;
				break;
		}
	}
Finish:
	mBuf[pDestPos] = '\0';
	if(pLastArgNotExist)
		C--;
	V[C] = NULL;
}


cls_ArgPerse::~cls_ArgPerse()
{
	V = NULL;
	mBuf = NULL;
	HeapDestroy(mHeap);
	mHeap = NULL;
}
