/*********************************************************************
 * clsVer.cpp
 *     o[W擾NX
 * Author
 *     "ĂƁ" <tategoto@harpy.org>
 * Updated
 *     2002/02/06
 *********************************************************************/


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// wb_[CN[h ////////////

#include  "clsVer.h"


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// o[W擾 API Gǧ^錾 ////////////

typedef  DWORD  (WINAPI *Func_GetFileVersionInfoSize)(LPTSTR lptstrFilename, LPDWORD lpdwHandle);
typedef  BOOL   (WINAPI *Func_GetFileVersionInfo    )(LPTSTR lptstrFilename, DWORD dwHandle, DWORD dwLen, LPVOID lpData);
typedef  BOOL   (WINAPI *Func_VerQueryValue         )(const LPVOID pBlock, LPTSTR lpSubBlock, LPVOID *lplpBuffer, PUINT puLen);


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// RXgN^ / fXgN^ ////////////

// RXgN^
cls_GetVersion::cls_GetVersion(LPCSTR NewTarget)
{
	// oϐ̏
	hHeap        = HeapCreate(NULL, NULL, NULL);
	TargetFile   = NULL;
	InfoResource = NULL;

	// ^[Qbgt@C̐ݒ
	SetTarget(NewTarget);
}


////////////////////////////////////////////////////////////////////////////////

// fXgN^
cls_GetVersion::~cls_GetVersion()
{
	// Ȃƃq[v
	if(hHeap != NULL)
		HeapDestroy(hHeap);
	// oϐ̃NA
	hHeap        = NULL;
	TargetFile   = NULL;
	InfoResource = NULL;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// J\bh ////////////

// ^[Qbgt@C̐ݒ
void  cls_GetVersion::SetTarget(LPCSTR NewTarget)
{
	// NULL Ԃ
	if(hHeap == NULL)
		return;

	// O܂ł̖Oi[͉
	if(TargetFile != NULL)
	{
		HeapFree(hHeap, NULL, TargetFile);
		TargetFile = NULL;
	}
	if(InfoResource != NULL)
	{
		HeapFree(hHeap, NULL, InfoResource);
		InfoResource = NULL;
	}

	//  NULL w肳ꂽꍇ̓JgvZX̋Nt@Cp
	if(NewTarget == NULL)
	{
		char  ProgramName[MAX_PATH];
		GetModuleFileName(GetModuleHandle(NULL), ProgramName, sizeof(ProgramName));
		NewTarget = ProgramName;
	}

	// ڕWt@Ci[
	size_t  PgmLen = strlen(NewTarget) + 1;
	TargetFile  = (LPSTR)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, PgmLen);
	if(TargetFile != NULL)
		MoveMemory(TargetFile, NewTarget, PgmLen);
}


////////////////////////////////////////////////////////////////////////////////

// o[W̎擾 (bv)
LPSTR  cls_GetVersion::Get(en_InfoKey InfoKey)
{
	LPCSTR  InfoKeyStr = NULL;
	switch(InfoKey)
	{
		case InfoKey_Comments        : InfoKeyStr = "Comments"        ; break;
		case InfoKey_CompanyName     : InfoKeyStr = "CompanyName"     ; break;
		case InfoKey_FileDescription : InfoKeyStr = "FileDescription" ; break;
		case InfoKey_FileVersion     : InfoKeyStr = "FileVersion"     ; break;
		case InfoKey_InternalName    : InfoKeyStr = "InternalName"    ; break;
		case InfoKey_LegalCopyright  : InfoKeyStr = "LegalCopyright"  ; break;
		case InfoKey_LegalTrademarks : InfoKeyStr = "LegalTrademarks" ; break;
		case InfoKey_OriginalFilename: InfoKeyStr = "OriginalFilename"; break;
		case InfoKey_PrivateBuild    : InfoKeyStr = "PrivateBuild"    ; break;
		case InfoKey_ProductName     : InfoKeyStr = "ProductName"     ; break;
		case InfoKey_ProductVersion  : InfoKeyStr = "ProductVersion"  ; break;
		case InfoKey_SpecialBuild    : InfoKeyStr = "SpecialBuild"    ; break;
		default:
			return NULL;
	}
	return Get(InfoKeyStr);
}


////////////////////////////////////////////////////////////////////////////////

// o[W̎擾 ({)
LPSTR  cls_GetVersion::Get(LPCSTR InfoKey)
{
	// NULL Ԃ
	if(InfoKey == NULL || TargetFile == NULL)
		return NULL;

	// API GǧŒ
	static bool                         VersionInfoInitialized = false;
	static Func_GetFileVersionInfoSize  My_GetFileVersionInfoSize;
	static Func_GetFileVersionInfo      My_GetFileVersionInfo;
	static Func_VerQueryValue           My_VerQueryValue;
	if(!VersionInfoInitialized)
	{
		HMODULE  hModuleVersion = LoadLibrary("Version");
		if(hModuleVersion == NULL)
			return NULL;
		My_GetFileVersionInfoSize = (Func_GetFileVersionInfoSize)GetProcAddress(hModuleVersion, "GetFileVersionInfoSizeA");
		My_GetFileVersionInfo     = (Func_GetFileVersionInfo    )GetProcAddress(hModuleVersion, "GetFileVersionInfoA"    );
		My_VerQueryValue          = (Func_VerQueryValue         )GetProcAddress(hModuleVersion, "VerQueryValueA"         );
		VersionInfoInitialized = true;
	}

	// 񃊃\[X̎擾
	if(InfoResource == NULL)
	{
		DWORD  dwHandle;
		DWORD  dwInfoSize = My_GetFileVersionInfoSize(TargetFile, &dwHandle);
		if(!dwInfoSize)
			return NULL;

		InfoResource = (LPSTR)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, dwInfoSize);
		if(InfoResource == NULL)
			return NULL;

		if(!My_GetFileVersionInfo(TargetFile, dwHandle, dwInfoSize, InfoResource))
		{
			HeapFree(hHeap, NULL, InfoResource);
			InfoResource = NULL;
			return NULL;
		}
	}

	// o[W̎擾̂߂̃P[擾
	struct  LANGANDCODEPAGE  {
	  WORD  wLanguage;
	  WORD  wCodePage;
	}     *lpTranslate;
	UINT  CodePageSize;
	if(!My_VerQueryValue(InfoResource, "\\VarFileInfo\\Translation", (LPVOID*)&lpTranslate, &CodePageSize))
		return NULL;

	// o[W̎擾̂߂̃L[쐬邽߂̃obt@쐬
	//                \ + StringFileInfo + \ + wLanguage + wCodePage + \ + InfoKey          + \0
	size_t  KeySize = 1 +             14 + 1 +         4 +         4 + 1 + lstrlen(InfoKey) + 1;
	LPSTR   InfoKeyStr = (LPSTR)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, KeySize);
	if(InfoKeyStr == NULL)
		return NULL;

	// P[TĖړI̕To
	LPSTR  Ret = NULL;
	LPSTR  VInfo;
	UINT   VSize;
	for(UINT  i = 0; i < (CodePageSize / sizeof(struct LANGANDCODEPAGE)); i++)
	{
		// o[W̎擾̂߂̃L[쐬
		wsprintf(InfoKeyStr, "\\StringFileInfo\\%04x%04x\\%s", (DWORD)lpTranslate[i].wLanguage, (DWORD)lpTranslate[i].wCodePage, InfoKey);

		// o[W̎擾
		if(My_VerQueryValue(InfoResource, InfoKeyStr, (LPVOID *)&VInfo, &VSize))
		{
			// o[W̎擾ɐARs[ă[v𔲂ĊM
			Ret = (LPSTR)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, VSize + 1);
			if(Ret)
			{
				MoveMemory(Ret, VInfo, VSize);
				break;
			}
		}
	}

	// M
	HeapFree(hHeap, NULL, InfoKeyStr);
	return Ret;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
